#include <stdexcept>
#include <iostream>
#include "StopWatch.h"

using namespace std;

StopWatch::StopWatch()
  {
    startTime = clock();
    stopTime  = 0;

    isRunning = true;
  }

void StopWatch::start()
  {
    startTime = clock();
    isRunning = true;
  }

void StopWatch::stop()
  {
    if (!isRunning)
        throw invalid_argument("StopWatch::stop() can only be called if the stopwatch is currently running");

    stopTime = clock();

    isRunning = false;
  }

long StopWatch::getElapsedTimeInMilliseconds()
  {
    if (isRunning)
        throw invalid_argument("StopWatch::stop() can only be called if the stopwatch is currently stoppeed");

    return (long) (getElapsedTimeInSeconds()*1000);
  }

double StopWatch::getElapsedTimeInSeconds()
  {
    if (isRunning)
        throw invalid_argument("StopWatch::stop() can only be called if the stopwatch is currently stoppeed");

    return ((double) stopTime - (double) startTime)/CLOCKS_PER_SEC;
  }

double StopWatch::getElapsedTimeInMinutes()
  {
    return getElapsedTimeInSeconds()/60.0;
  }

double StopWatch::getElapsedTimeInHours()
  {
    return getElapsedTimeInMinutes()/60.0;
  }

long StopWatch::getStartTime()
  {
    return startTime;
  }

long StopWatch::getStopTime()
  {
    return stopTime;
  }
