#include <iostream>
#include <cstdlib>
#include <iomanip>
#include "Matrix.h"
#include "StopWatch.h"

using namespace std;

// all matrices are n by n
const int n = 1000;

Matrix makeRandomMatrix(int n);

int main()
  {
    Matrix a = makeRandomMatrix(n);
    Matrix b = makeRandomMatrix(n);

    StopWatch timer;

    timer.start();
    Matrix c = a*b;
    timer.stop();

    double totalTime = timer.getElapsedTimeInSeconds();
    cout << "total time in seconds = " << fixed << setprecision(6) << totalTime << endl;

    return 0;
  }

Matrix makeRandomMatrix(int n)
  {
    Matrix result(n, n);

    for (int i = 0;  i < n;   ++i)
      {
        for (int j = 0;  j < n;  ++j)
            result(i, j) = (double) rand();
      }

    return result;
  }
